// Borland C++ Builder
// Copyright (c) 1995, 1999 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'TdbDataSet.pas' rev: 4.00

#ifndef TdbDataSetHPP
#define TdbDataSetHPP

#pragma delphiheader begin
#pragma option push -w-
#include <TdbTypes.h>	// Pascal unit
#include <DBCommon.hpp>	// Pascal unit
#include <Db.hpp>	// Pascal unit
#include <Classes.hpp>	// Pascal unit
#include <SysUtils.hpp>	// Pascal unit
#include <SysInit.hpp>	// Pascal unit
#include <System.hpp>	// Pascal unit

//-- user supplied -----------------------------------------------------------

namespace Tdbdataset
{
//-- type declarations -------------------------------------------------------
#pragma option push -b-
enum TTdbFilterType { tftCondition, tftKeywords };
#pragma option pop

#pragma option push -b-
enum TTdbLockType { tltWriteLock, tltTotalLock };
#pragma option pop

typedef void __fastcall (__closure *TResolveLinkEvent)(System::TObject* Sender, int FieldNo, const AnsiString 
	LinkInfo, int &RecordId, bool &Cancel);

class DELPHICLASS TTdbDatabase;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TTdbDatabase : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	bool FConnected;
	void __fastcall SetConnected(bool AConnected);
	
public:
	__fastcall virtual ~TTdbDatabase(void);
	void __fastcall CheckRelationsClose(void);
	Shortint __fastcall CheckRelationOpen(AnsiString AFilePath, AnsiString APassword, int ACode, Word ARights
		);
	void __fastcall Open(void);
	void __fastcall Close(void);
	
__published:
	__property bool Connected = {read=FConnected, write=SetConnected, nodefault};
public:
	#pragma option push -w-inl
	/* TComponent.Create */ inline __fastcall virtual TTdbDatabase(Classes::TComponent* AOwner) : Classes::TComponent(
		AOwner) { }
	#pragma option pop
	
};

#pragma pack(pop)

#pragma option push -b-
enum TOutOfTableState { ootNone, ootBOT, ootEOT };
#pragma option pop

#pragma pack(push, 4)
struct TRecordInfo
{
	int RecordNo;
	Db::TBookmarkFlag BookmarkFlag;
} ;
#pragma pack(pop)

typedef TRecordInfo *PRecordInfo;

class DELPHICLASS TTdbDataSet;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TTdbDataSet : public Db::TDataSet 
{
	typedef Db::TDataSet inherited;
	
private:
	AnsiString FTableName;
	unsigned FKey;
	AnsiString FPassword;
	Shortint FRltnHdl;
	Word FRecBufSize;
	Classes::TList* FBlobList;
	bool FReadOnly;
	TOutOfTableState FOutOfTableState;
	TResolveLinkEvent FOnResolveLink;
	void __fastcall SetReadOnly(const bool Value);
	void __fastcall SetDatabaseName(AnsiString ADatabaseName);
	AnsiString __fastcall GetTableFileName(void);
	
protected:
	virtual void __fastcall DoBeforeScroll(void);
	virtual int __fastcall GetRecordCount(void);
	virtual int __fastcall GetRecNo(void);
	virtual void __fastcall InternalCancel(void);
	virtual void __fastcall InternalEdit(void);
	virtual void __fastcall InternalInsert(void);
	void __fastcall CheckDatabaseOpen(void);
	void __fastcall ClearBlobList(void);
	virtual void __fastcall CreateHandle(void);
	void __fastcall DestroyHandle(void);
	PRecordInfo __fastcall GetRecordInfo(char * Buffer);
	void __fastcall GotoActiveRecord(void);
	bool __fastcall LocateRecord(const AnsiString KeyFields, const Variant &KeyValues, Db::TLocateOptions 
		Options, bool SyncCursor);
	void __fastcall SetTableName(AnsiString ATableName);
	AnsiString __fastcall GetVersion(void);
	void __fastcall SetVersion(AnsiString AVersion);
	virtual char * __fastcall AllocRecordBuffer(void);
	virtual void __fastcall FreeRecordBuffer(char * &Buffer);
	virtual void __fastcall GetBookmarkData(char * Buffer, void * Data);
	virtual Db::TBookmarkFlag __fastcall GetBookmarkFlag(char * Buffer);
	bool __fastcall GetFieldDataFromBuffer(Db::TField* Field, void * Buffer, void * RecordBuf);
	short __fastcall GetTdbDataType(int AFieldNo);
	virtual Db::TGetResult __fastcall GetRecord(char * Buffer, Db::TGetMode GetMode, bool DoCheck);
	virtual Word __fastcall GetRecordSize(void);
	virtual void __fastcall InternalAddRecord(void * Buffer, bool Append);
	virtual void __fastcall InternalClose(void);
	virtual void __fastcall InternalDelete(void);
	virtual void __fastcall InternalFirst(void);
	virtual void __fastcall InternalGotoBookmark(void * Bookmark);
	virtual void __fastcall InternalHandleException(void);
	virtual void __fastcall InternalInitFieldDefs(void);
	virtual void __fastcall InternalInitRecord(char * Buffer);
	virtual void __fastcall InternalLast(void);
	virtual void __fastcall InternalOpen(void);
	virtual void __fastcall InternalPost(void);
	virtual void __fastcall InternalSetToRecord(char * Buffer);
	virtual bool __fastcall IsCursorOpen(void);
	virtual void __fastcall SetBookmarkFlag(char * Buffer, Db::TBookmarkFlag Value);
	virtual void __fastcall SetBookmarkData(char * Buffer, void * Data);
	virtual void __fastcall SetFieldData(Db::TField* Field, void * Buffer);
	__property AnsiString TableName = {read=FTableName, write=SetTableName};
	__property AnsiString TableFileName = {read=GetTableFileName};
	__property short TdbDataType[int FieldNo] = {read=GetTdbDataType};
	Shortint FTableHdl;
	AnsiString FDatabaseName;
	TTdbDatabase* FDatabase;
	
public:
	__fastcall virtual TTdbDataSet(Classes::TComponent* AOwner);
	__fastcall virtual ~TTdbDataSet(void);
	virtual Classes::TStream* __fastcall CreateBlobStream(Db::TField* Field, Db::TBlobStreamMode Mode);
		
	virtual bool __fastcall GetFieldData(Db::TField* Field, void * Buffer)/* overload */;
	virtual bool __fastcall Locate(const AnsiString KeyFields, const Variant &KeyValues, Db::TLocateOptions 
		Options);
	virtual Variant __fastcall Lookup(const AnsiString KeyFields, const Variant &KeyValues, const AnsiString 
		ResultFields);
	virtual int __fastcall Translate(char * Src, char * Dest, bool ToOem);
	__property Shortint TableHdl = {read=FTableHdl, nodefault};
	
__published:
	__property Active ;
	__property FieldDefs ;
	__property bool ReadOnly = {read=FReadOnly, write=SetReadOnly, nodefault};
	__property AnsiString DatabaseName = {read=FDatabaseName, write=SetDatabaseName};
	__property AnsiString Version = {read=GetVersion, write=SetVersion};
	__property TResolveLinkEvent OnResolveLink = {read=FOnResolveLink, write=FOnResolveLink};
	__property BeforeOpen ;
	__property AfterOpen ;
	__property BeforeClose ;
	__property AfterClose ;
	__property BeforeInsert ;
	__property AfterInsert ;
	__property BeforeEdit ;
	__property AfterEdit ;
	__property BeforePost ;
	__property AfterPost ;
	__property BeforeCancel ;
	__property AfterCancel ;
	__property BeforeDelete ;
	__property AfterDelete ;
	__property BeforeScroll ;
	__property AfterScroll ;
	__property OnCalcFields ;
	__property OnDeleteError ;
	__property OnEditError ;
	__property OnNewRecord ;
	__property OnPostError ;
};

#pragma pack(pop)

class DELPHICLASS TIndexFiles;
class DELPHICLASS TTdbTable;
#pragma pack(push, 4)
class PASCALIMPLEMENTATION TTdbTable : public TTdbDataSet 
{
	typedef TTdbDataSet inherited;
	
private:
	bool FExclusive;
	TTdbFilterType FFilterType;
	AnsiString FIndexName;
	Classes::TStrings* FIndexFiles;
	Db::TIndexDefs* FIndexDefs;
	Dbcommon::TMasterDataLink* FMasterLink;
	Db::TDataSource* FMasterSource;
	TTdbTable* FFullTextTable;
	void __fastcall SetDataSource(Db::TDataSource* Value);
	void __fastcall MasterChanged(System::TObject* Sender);
	void __fastcall MasterDisabled(System::TObject* Sender);
	void __fastcall SetIndexFiles(Classes::TStrings* AIndexFiles);
	
protected:
	virtual void __fastcall InternalClose(void);
	virtual void __fastcall InternalOpen(void);
	virtual bool __fastcall FindRecord(bool Restart, bool GoForward);
	AnsiString __fastcall GetMasterFields(void);
	virtual void __fastcall SetFiltered(bool Value);
	virtual void __fastcall SetFilterText(const AnsiString Value);
	void __fastcall SetFilterType(TTdbFilterType AFilterType);
	void __fastcall SetMasterFields(const AnsiString Value);
	virtual void __fastcall UpdateIndexDefs(void);
	virtual void __fastcall CreateHandle(void);
	void __fastcall MasterSourceChanged(void);
	void __fastcall ApplyFilter(void);
	void __fastcall ApplyIndex(void);
	void __fastcall SetExclusive(bool AExclusive);
	void __fastcall CheckRelationOpen(void);
	
public:
	__fastcall virtual TTdbTable(Classes::TComponent* AOwner);
	__fastcall virtual ~TTdbTable(void);
	void __fastcall SetIndexName(const AnsiString Value);
	void __fastcall AddIndex(const AnsiString Name, const AnsiString Fields, Db::TIndexOptions Options, 
		const AnsiString DescFields);
	void __fastcall DeleteIndex(const AnsiString Name);
	void __fastcall EmptyTable(void);
	void __fastcall DeleteTable(void);
	
__published:
	__property bool Exclusive = {read=FExclusive, write=SetExclusive, nodefault};
	__property Db::TIndexDefs* IndexDefs = {read=FIndexDefs};
	__property AnsiString IndexName = {read=FIndexName, write=SetIndexName};
	__property Classes::TStrings* IndexFiles = {read=FIndexFiles, write=SetIndexFiles};
	__property Filter ;
	__property Filtered ;
	__property TTdbFilterType FilterType = {read=FFilterType, write=SetFilterType, nodefault};
	__property TTdbTable* FullTextTable = {read=FFullTextTable, write=FFullTextTable};
	__property unsigned Key = {read=FKey, write=FKey, nodefault};
	__property AnsiString MasterFields = {read=GetMasterFields};
	__property Db::TDataSource* MasterSource = {read=FMasterSource, write=SetDataSource};
	__property AnsiString Password = {read=FPassword, write=FPassword};
	__property TableName ;
};

#pragma pack(pop)

#pragma pack(push, 4)
class PASCALIMPLEMENTATION TIndexFiles : public Classes::TStringList 
{
	typedef Classes::TStringList inherited;
	
private:
	TTdbTable* FOwner;
	
public:
	__fastcall TIndexFiles(TTdbTable* AOwner);
	virtual int __fastcall Add(const AnsiString S);
	virtual void __fastcall Clear(void);
	virtual void __fastcall Delete(int Index);
	virtual void __fastcall Insert(int Index, const AnsiString S);
public:
	#pragma option push -w-inl
	/* TStringList.Destroy */ inline __fastcall virtual ~TIndexFiles(void) { }
	#pragma option pop
	
};

#pragma pack(pop)

//-- var, const, procedure ---------------------------------------------------
static const Shortint TurboDBMainVersion = 0x2;
static const Shortint TurboDBSubVersion = 0x1;
static const Shortint TurboDBBuild = 0x18;
extern PACKAGE void __fastcall TdbDatabaseError(AnsiString Context, int Code);
extern PACKAGE void __fastcall TdbDatabaseErrorFmt(AnsiString Context, const System::TVarRec * Args, 
	const int Args_Size, int Code);
extern PACKAGE void __fastcall Register(void);

}	/* namespace Tdbdataset */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Tdbdataset;
#endif
#pragma option pop	// -w-

#pragma delphiheader end.
//-- end unit ----------------------------------------------------------------
#endif	// TdbDataSet
